#include "globals.h"



// popen2.h
FILE *writepipe, *readpipe, *config;
int pid;



// parse.h
struct breakpoint_struct breakpoints[30];
struct cpu_t cpu;
unsigned   i_virtual_segment;
unsigned   i_virtual_offset;
unsigned   i_physical_address;
unsigned   i_size;
char       i_description[STRING_LENGTH];
int        p_step;
int        bp_type;



// buttons.h
FL_OBJECT *c_hislen_text, *c_sabove_text, *c_sbelow_text, *c_steplock_text, *c_nextlock_text;

FL_OBJECT *m_linear, *m_physical, *trace_checkbox, *clear_hislog_button;
FL_OBJECT *quit_button, *hide_button, *show_button, *state_widgets, *refreshall_button, *dummy;
FL_OBJECT *dump_button, *add_button, *remove_button, *clearall_button;
FL_OBJECT *go_button, *step_button, *stop_button, *next_button;
FL_OBJECT *physical_check, *linear_check, *virtual_check;
FL_OBJECT *m_size_byte, *m_size_word, *m_size_dword, *m_size_qword;
FL_OBJECT *m_type_hex, *m_type_dec, *m_type_uns, *m_type_oct, *m_type_bin;

FL_OBJECT *r_eax_text, *r_ebx_text, *r_ecx_text, *r_edx_text, *r_ebp_text, *r_esi_text, *r_edi_text, *r_esp_text;
FL_OBJECT *r_eflags_text, *r_eip_text, *r_cs_text, *r_ss_text, *r_ds_text, *r_es_text, *r_fs_text, *r_gs_text;
FL_OBJECT *r_ldtr_text, *r_tr_text, *r_gdtr_text, *r_idtr_text;
FL_OBJECT *r_dr0_text, *r_dr1_text, *r_dr2_text, *r_dr3_text, *r_dr4_text, *r_dr5_text, *r_dr6_text, *r_dr7_text;
FL_OBJECT *r_tr3_text, *r_tr4_text, *r_tr5_text, *r_tr6_text, *r_tr7_text;
FL_OBJECT *r_cr0_text, *r_cr1_text, *r_cr2_text, *r_cr3_text, *r_cr4_text;

FL_FORM *window, *f_config_folder, *f_structures_folder, *f_memory_folder, *f_breakpoints_folder;
FL_FORM *quitConfirm, *f_history_folder;
FL_OBJECT *yes, *no, *i_list;
FL_OBJECT *i_address_text, *i_offset_text, *i_instruction_text;
FL_OBJECT *b_list, *b_address_text;
FL_OBJECT *m_address_text, *m_size_text;
FL_OBJECT *s_list, *st_list, *f_list;
FL_OBJECT *event, *folder, *main_group;

struct memwin_struct *mem_windows;

int  next_active, bochs_running, update_state, bochs_offline, tracing;
char mem_type, mem_size, mem_physical;
unsigned steplock_time, nextlock_time;
long history_repeat;
FILE *history_logfile;
char history_lastline[200];



// structures.h
struct mem_struct *memlist;
unsigned stack_above, stack_below;
unsigned history_length;
int nr_strucs;
