state_widgets = fl_bgn_group();



	//-----------------------------
	// stack
	//-----------------------------
	fl_add_text(FL_NORMAL_TEXT,                        5, 200, 115,  20, "Stack");
	s_list = fl_add_browser(FL_HOLD_BROWSER,           5, 220, 140, 140, NULL);
	fl_set_object_lstyle(s_list, FL_FIXED_STYLE);



	//-----------------------------
	// registers
	//-----------------------------
	fl_add_text(FL_NORMAL_TEXT,                      145, 200,  30, 20, "EAX");
	fl_add_text(FL_NORMAL_TEXT,                      145, 220,  30, 20, "EBX");
	fl_add_text(FL_NORMAL_TEXT,                      145, 240,  30, 20, "ECX");
	fl_add_text(FL_NORMAL_TEXT,                      145, 260,  30, 20, "EDX");
	fl_add_text(FL_NORMAL_TEXT,                      145, 280,  30, 20, "EBP");
	fl_add_text(FL_NORMAL_TEXT,                      145, 300,  30, 20, "ESI");
	fl_add_text(FL_NORMAL_TEXT,                      145, 320,  30, 20, "EDI");
	fl_add_text(FL_NORMAL_TEXT,                      145, 340,  30, 20, "ESP");
	r_eax_text = fl_add_input(FL_NORMAL_INPUT,       175, 200,  75, 20, NULL);
	r_ebx_text = fl_add_input(FL_NORMAL_INPUT,       175, 220,  75, 20, NULL);
	r_ecx_text = fl_add_input(FL_NORMAL_INPUT,       175, 240,  75, 20, NULL);
	r_edx_text = fl_add_input(FL_NORMAL_INPUT,       175, 260,  75, 20, NULL);
	r_ebp_text = fl_add_input(FL_NORMAL_INPUT,       175, 280,  75, 20, NULL);
	r_esi_text = fl_add_input(FL_NORMAL_INPUT,       175, 300,  75, 20, NULL);
	r_edi_text = fl_add_input(FL_NORMAL_INPUT,       175, 320,  75, 20, NULL);
	r_esp_text = fl_add_input(FL_NORMAL_INPUT,       175, 340,  75, 20, NULL);
	fl_deactivate_object(r_eax_text);
	fl_deactivate_object(r_ebx_text);
	fl_deactivate_object(r_ecx_text);
	fl_deactivate_object(r_edx_text);
	fl_deactivate_object(r_ebp_text);
	fl_deactivate_object(r_esi_text);
	fl_deactivate_object(r_edi_text);
	fl_deactivate_object(r_esp_text);
	fl_set_object_lstyle(r_eax_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_ebx_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_ecx_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_edx_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_ebp_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_esi_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_edi_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_esp_text, FL_BOLD_STYLE);


	fl_add_text(FL_NORMAL_TEXT,                      450, 200,  50, 20, "EFLAGS");
	fl_add_text(FL_NORMAL_TEXT,                      450, 220,  40, 20, "EIP");
	fl_add_text(FL_NORMAL_TEXT,                      400, 240,  40, 20, "GDTR");
	fl_add_text(FL_NORMAL_TEXT,                      400, 260,  40, 20, "IDTR");
	r_eflags_text = fl_add_input(FL_NORMAL_INPUT,    500, 200,  75, 20, NULL);
	r_eip_text = fl_add_input(FL_NORMAL_INPUT,       500, 220,  75, 20, NULL);
	r_gdtr_text = fl_add_input(FL_NORMAL_INPUT,      440, 240, 135, 20, NULL);
	r_idtr_text = fl_add_input(FL_NORMAL_INPUT,      440, 260, 135, 20, NULL);
	fl_deactivate_object(r_eflags_text);
	fl_deactivate_object(r_eip_text);
	fl_deactivate_object(r_gdtr_text);
	fl_deactivate_object(r_idtr_text);
	fl_set_object_lstyle(r_eflags_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_eip_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_gdtr_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_idtr_text, FL_BOLD_STYLE);


	fl_add_text(FL_NORMAL_TEXT,                      255, 200,  40, 20, "LDTR");
	fl_add_text(FL_NORMAL_TEXT,                      255, 220,  40, 20, "TR");
	fl_add_text(FL_NORMAL_TEXT,                      255, 240,  25, 20, "CS");
	fl_add_text(FL_NORMAL_TEXT,                      255, 260,  25, 20, "SS");
	fl_add_text(FL_NORMAL_TEXT,                      255, 280,  25, 20, "DS");
	fl_add_text(FL_NORMAL_TEXT,                      255, 300,  25, 20, "ES");
	fl_add_text(FL_NORMAL_TEXT,                      255, 320,  25, 20, "FS");
	fl_add_text(FL_NORMAL_TEXT,                      255, 340,  25, 20, "GS");
	r_ldtr_text = fl_add_input(FL_NORMAL_INPUT,      295, 200, 120, 20, NULL);
	r_tr_text = fl_add_input(FL_NORMAL_INPUT,        295, 220, 120, 20, NULL);
	r_cs_text = fl_add_input(FL_NORMAL_INPUT,        280, 240, 100, 20, NULL);
	r_ss_text = fl_add_input(FL_NORMAL_INPUT,        280, 260, 100, 20, NULL);
	r_ds_text = fl_add_input(FL_NORMAL_INPUT,        280, 280, 100, 20, NULL);
	r_es_text = fl_add_input(FL_NORMAL_INPUT,        280, 300, 100, 20, NULL);
	r_fs_text = fl_add_input(FL_NORMAL_INPUT,        280, 320, 100, 20, NULL);
	r_gs_text = fl_add_input(FL_NORMAL_INPUT,        280, 340, 100, 20, NULL);
	fl_deactivate_object(r_ldtr_text);
	fl_deactivate_object(r_tr_text);
	fl_deactivate_object(r_cs_text);
	fl_deactivate_object(r_ss_text);
	fl_deactivate_object(r_ds_text);
	fl_deactivate_object(r_es_text);
	fl_deactivate_object(r_fs_text);
	fl_deactivate_object(r_gs_text);
	fl_set_object_lstyle(r_ldtr_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_tr_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_cs_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_ss_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_ds_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_es_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_fs_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_gs_text, FL_BOLD_STYLE);


	fl_add_text(FL_NORMAL_TEXT,                       5, 370,  30, 20, "DR0");
	fl_add_text(FL_NORMAL_TEXT,                       5, 390,  30, 20, "DR1");
	fl_add_text(FL_NORMAL_TEXT,                       5, 410,  30, 20, "DR2");
	fl_add_text(FL_NORMAL_TEXT,                       5, 430,  30, 20, "DR3");
//	fl_add_text(FL_NORMAL_TEXT,                       5, 450,  30, 20, "DR4");
//	fl_add_text(FL_NORMAL_TEXT,                       5, 470,  30, 20, "DR5");
	fl_add_text(FL_NORMAL_TEXT,                       5, 490,  30, 20, "DR6");
	fl_add_text(FL_NORMAL_TEXT,                       5, 510,  30, 20, "DR7");
	r_dr0_text = fl_add_input(FL_NORMAL_INPUT,       35, 370,  75, 20, NULL);
	r_dr1_text = fl_add_input(FL_NORMAL_INPUT,       35, 390,  75, 20, NULL);
	r_dr2_text = fl_add_input(FL_NORMAL_INPUT,       35, 410,  75, 20, NULL);
	r_dr3_text = fl_add_input(FL_NORMAL_INPUT,       35, 430,  75, 20, NULL);
//	r_dr4_text = fl_add_input(FL_NORMAL_INPUT,       35, 450,  75, 20, NULL);
//	r_dr5_text = fl_add_input(FL_NORMAL_INPUT,       35, 470,  75, 20, NULL);
	r_dr6_text = fl_add_input(FL_NORMAL_INPUT,       35, 490,  75, 20, NULL);
	r_dr7_text = fl_add_input(FL_NORMAL_INPUT,       35, 510,  75, 20, NULL);
	fl_deactivate_object(r_dr0_text);
	fl_deactivate_object(r_dr1_text);
	fl_deactivate_object(r_dr2_text);
	fl_deactivate_object(r_dr3_text);
//	fl_deactivate_object(r_dr4_text);
//	fl_deactivate_object(r_dr5_text);
	fl_deactivate_object(r_dr6_text);
	fl_deactivate_object(r_dr7_text);
	fl_set_object_lstyle(r_dr0_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_dr1_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_dr2_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_dr3_text, FL_BOLD_STYLE);
//	fl_set_object_lstyle(r_dr4_text, FL_BOLD_STYLE);
//	fl_set_object_lstyle(r_dr5_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_dr6_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_dr7_text, FL_BOLD_STYLE);


	fl_add_text(FL_NORMAL_TEXT,                      125, 430,  30, 20, "TR3");
	fl_add_text(FL_NORMAL_TEXT,                      125, 450,  30, 20, "TR4");
	fl_add_text(FL_NORMAL_TEXT,                      125, 470,  30, 20, "TR5");
	fl_add_text(FL_NORMAL_TEXT,                      125, 490,  30, 20, "TR6");
	fl_add_text(FL_NORMAL_TEXT,                      125, 510,  30, 20, "TR7");
	r_tr3_text = fl_add_input(FL_NORMAL_INPUT,       155, 430,  75, 20, NULL);
	r_tr4_text = fl_add_input(FL_NORMAL_INPUT,       155, 450,  75, 20, NULL);
	r_tr5_text = fl_add_input(FL_NORMAL_INPUT,       155, 470,  75, 20, NULL);
	r_tr6_text = fl_add_input(FL_NORMAL_INPUT,       155, 490,  75, 20, NULL);
	r_tr7_text = fl_add_input(FL_NORMAL_INPUT,       155, 510,  75, 20, NULL);
	fl_deactivate_object(r_tr3_text);
	fl_deactivate_object(r_tr4_text);
	fl_deactivate_object(r_tr5_text);
	fl_deactivate_object(r_tr6_text);
	fl_deactivate_object(r_tr7_text);
	fl_set_object_lstyle(r_tr3_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_tr4_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_tr5_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_tr6_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_tr7_text, FL_BOLD_STYLE);


	fl_add_text(FL_NORMAL_TEXT,                      245, 370,  30, 20, "CR0");
	fl_add_text(FL_NORMAL_TEXT,                      245, 390,  30, 20, "CR1");
	fl_add_text(FL_NORMAL_TEXT,                      245, 410,  30, 20, "CR2");
	fl_add_text(FL_NORMAL_TEXT,                      245, 430,  30, 20, "CR3");
	fl_add_text(FL_NORMAL_TEXT,                      245, 450,  30, 20, "CR4");
	r_cr0_text = fl_add_input(FL_NORMAL_INPUT,       275, 370,  75, 20, NULL);
	r_cr1_text = fl_add_input(FL_NORMAL_INPUT,       275, 390,  75, 20, NULL);
	r_cr2_text = fl_add_input(FL_NORMAL_INPUT,       275, 410,  75, 20, NULL);
	r_cr3_text = fl_add_input(FL_NORMAL_INPUT,       275, 430,  75, 20, NULL);
	r_cr4_text = fl_add_input(FL_NORMAL_INPUT,       275, 450,  75, 20, NULL);
	fl_deactivate_object(r_cr0_text);
	fl_deactivate_object(r_cr1_text);
	fl_deactivate_object(r_cr2_text);
	fl_deactivate_object(r_cr3_text);
	fl_deactivate_object(r_cr4_text);
	fl_set_object_lstyle(r_cr0_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_cr1_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_cr2_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_cr3_text, FL_BOLD_STYLE);
	fl_set_object_lstyle(r_cr4_text, FL_BOLD_STYLE);


	//-----------------------------
	// eflags list
	//-----------------------------
	f_list = fl_add_browser(FL_HOLD_BROWSER,      385, 295, 190, 235, NULL);
	fl_set_object_lstyle(f_list, FL_FIXED_STYLE);


fl_end_group();
